package br.com.rayankonecny.userserviceapi.controller.impl;

import static br.com.rayankonecny.userserviceapi.creator.CreatorUtils.generateMock;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.HttpStatus;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.web.servlet.MockMvc;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.jsonPath;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import java.util.List;

import br.com.rayankonecny.userserviceapi.entity.User;
import br.com.rayankonecny.userserviceapi.repository.UserRepository;

@SpringBootTest
@AutoConfigureMockMvc
@ActiveProfiles("test")
public class UserControllerImpTest {

  @Autowired
  private MockMvc mockMvc;

  @Autowired
  private UserRepository userRepository;

  @Test
  void testFindByIdWithSucces() throws Exception {
    final var entity = generateMock(User.class);
    final var userId = userRepository.save(entity).getId();

    mockMvc.perform(get("/api/users/{id}", userId)).andExpect(status().isOk()).andExpect(jsonPath("$.id").value(userId))
        .andExpect(jsonPath("$.name").value(entity.getName())).andExpect(jsonPath("$.email").value(entity.getEmail()))
        .andExpect(jsonPath("$.password").value(entity.getPassword())).andExpect(jsonPath("$.profiles").isArray());

    userRepository.deleteById(userId);
  }

  @Test
  void testFindByIdWithNotFoundException() throws Exception {
    mockMvc.perform(get("/api/users/{id}", "123")).andExpect(status().isNotFound())
        .andExpect(jsonPath("$.message").value("Object not found! Id: 123, Type: UserResponse"))
        .andExpect(jsonPath("$.error").value(HttpStatus.NOT_FOUND.getReasonPhrase()))
        .andExpect(jsonPath("$.path").value("/api/users/123"))
        .andExpect(jsonPath("$.status").value(HttpStatus.NOT_FOUND.value()))
        .andExpect(jsonPath("$.timestamp").isNotEmpty());
  }

  @Test
  void testFindAllWithSuccess() throws Exception {
    final var entity1 = generateMock(User.class);
    final var entity2 = generateMock(User.class);

    userRepository.saveAll(List.of(entity1, entity2));

    mockMvc.perform(get("/api/users"))
      .andExpect(status().isOk())
      .andExpect(jsonPath("$").isArray())
      .andExpect(jsonPath("$[0]").isNotEmpty())
      .andExpect(jsonPath("$[1]").isNotEmpty())
      .andExpect(jsonPath("$[0].profiles").isArray());

    userRepository.deleteAll(List.of(entity1,entity2));

  }

}
